function [u, nb_iter, nresid] = GPO (A,b,u0,epsilon,max_iter)
nb_iter=0;
u=u0;resid=A*u0-b;   
while(nb_iter<max_iter) & (norm(resid)>epsilon)
  rhok=(resid'*resid)/((A*resid)'*resid)  
  u=u-rhok*resid;
  resid=A*u-b; 
  nb_iter=nb_iter+1 
end 
nresid=norm(resid)   
endfunction
//
A=diag([3,12,24,48,96])+diag([-1,-1,-1,-1],-1)+diag([-1,-1,-1,-1],1)
b=[1;2;3;4;5]
u0=zeros(5,1);
epsilon=1E-5
max_iter=20000;
//
[u, nb_iter, resid] = GPO (A,b,u0,epsilon,max_iter)
disp('valeur de u:');
disp(u)
disp('nbre d''iterations:')
disp(nb_iter)   


