
function [utot, nb_iter] = GPObis (A,b,u0,epsilon,max_iter)
nb_iter=0;
utot=u0;resid=A*u0-b;u=u0;   
while(nb_iter<max_iter) & (norm(resid)>epsilon)
  rhok=(resid'*resid)/((A*resid)'*resid)  
  u=u-rhok*resid;
  utot=[utot,u]
  resid=A*u-b; 
  nb_iter=nb_iter+1 
end 
nresid=norm(resid)   
endfunction
//
// exemple avec représentation graphique
//
A=diag([1,3]);
P=[1,2;-1,1];
A=P*A*inv(P);
b=A*[1;3];
u0=[0;0];
epsilon=1E-6;
//
function y=J(x)
    y=1/2*(A*x)'*x-b'*x
endfunction
x=-0.5:0.1:4;y=-0.5:0.1:4;
z=zeros(length(x),length(y))
for i=1:length(x)
    for j=1:length(y)
      z(i,j)=J([x(i);y(j)])  
    end  
end
//
[utot, nb_iter] = GPObis (A,b,u0,epsilon,max_iter)
//
clf()
contour(x,y,z,20)
plot(utot(1,:),utot(2,:))


